/* jstrskip -
   Copyright (C) 1995  Katsuyuki Okabe <hgc02147@niftyserve.or.jp>

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public License
   as published by the Free Software Foundation; either version 2 of
   the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

#include "xjctype.h"
#include "xjstring.h"

char *
jstrskip(string1, string2)
     const char *string1;
     const char *string2;
{
  const unsigned char *s1;
  unsigned int c;

  s1 = (const unsigned char *)string1;
  while ((c = *s1++) != '\0')
    {
      if (iskanji(c))
	c = (c << 8) + *s1++;
      if (jstrchr(string2, c) == (char *)NULL)
	return (char *)string1;
      string1 = (const char *)s1;
    }

  return (char *)NULL;
}

/*
 * End:
 */
