.TH XTR 1
.\"
.SH NAME
xtr \- format documents
.\"
.SH SYNOPSIS
.B xtr
[
.IR options \|.\|.\|.\|
] [
.IR \fB\-\fPcommands \|.\|.\|.\|
] [ 
.IR files \|.\|.\|.\|
]
.\"
.SH DESCRIPTION
.\"
.SH OPTIONS
.TP
.BI \-\-ctype= ctype
Treat input/output character set as
.IR ctype .
.I ctype
is
.B EUC
or
.BR SJIS .
.B EUC
allow X0201 kana.
.TP
.BI \-\-tmpdir= tempdir
This option is another way to select the diretory for temporary files;
it the overrides the environment variable
.BR TMPDIR .
.SH COMMANDS
.TP
.B e
Enable commands in a writting.
.TP
.BI w \fR[\fPwidth\fR]\fP
Fill output lines to up
.I width
columns (default 72).
.TP
.BI f \fR[\fPn\fR]\fP
Fill a line with input lines.
.TP
.BI a \fR[\fPn\fR]\fP
Justify mode. Arrange ends of a line by adjusting spaces in the line.
.I n
is the maximum of spaces at one place (default 5).
.TP
.B aj
Justify mode without surplus spaces.
.TP
.B sj
Remove surplus spaces.
.TP
.B ac
Centering each line.
.TP
.B ar
Insert some spaces at beginning of each line, to put an end of the
line on a last column.
.TP
.B ab
Assign equially spaces between words in each line on a last column.
.TP
.B as
Insert spaces between English words and Japanese words.
.TP
.B ss
Leave no space between English words and Japanese words.
.TP
.B al
Leave a space at ends of a paragraph.
.TP
.BI ai \fR[\fPn\fR]\fP
Auto indent mode.
.TP
.BI i \fR[\fPn\fR]\fP
Put
.I n
spaces at beginning of each line (default 0).
.TP
.BI h \fR[\fPn\fR]\fP
Put
.I n
spaces at beginning of line after second line in a paragraph (default 2).
.TP
.BI ip \fR[\fPn\fR]\fP
Put
.I n
spaces at beginning of first line in a paragraph (default 2).
.TP
.BI ii \fR[\fPn\fR]\fP
.TP
.BI il \fR[\fPn\fR]\fP
.TP
.BI l \fR[\fPn\fR]\fP
(default 1).
.TP
.B q
.TP
.BI t \fR[\fPn\fR]\fP
(default 8).
.TP
.BI s \fR[\fPn\fR]\fP
(default 8).
.TP
.B sz
.TP
.B sh
.TP
.B sn
Enable spaces at end of line.
.TP
.B pg
.TP
.B p
.TP
.B n
.TP
.BI sp \fR[\fPn\fR]\fP
(default 1).
.TP
.B ln
.TP
.B pl
.TP
.B ph
.TP
.B pf
.TP
.B ps
.TP
.B pt
.TP
.B pb
.TP
.B po
.TP
.B pp
.TP
.B px
.TP
.B pn
.TP
.B np
.TP
.B nr
.TP
.B pm
.TP
.B pv
.TP
.B pw
.TP
.B r/
.TP
.B rc
.TP
.B ko
.TP
.B kn
.TP
.B kh
.TP
.B kc
.TP
.B kz
.TP
.B kk
.TP
.B kx
.TP
.B kf
.TP
.B ke
.TP
.B kt
.TP
.B kd
.TP
.B km
.TP
.B ka
.TP
.B ki
.TP
.B ks
.TP
.B kp
.TP
.B hz
.TP
.B ch
.TP
.B cz
.TP
.B m
.TP
.B o
.TP
.B nn
.TP
.B nk
.TP
.B b
.TP
.B \-
Disable command previous from this.
Usually use to disable the environment variable
.BR XTR .
.TP
.B /
non verbose mode.
.TP
.BI @ macro\-file
Read the XTR
.IR macro\-file .
default suffix \`.xtr\'.
.TP
.B [ ]
.TP
.B $
.\"
.TP
.B .
.TP
.B ~.
.TP
.B ~/
.TP
.B ~> ~<
.TP
.B ~\e
.TP
.B ~%
.TP
.B ~{ ~}
.TP
.B ~|
.\"
.SH ENVIRONMENT
.TP
.B LANG
Language for determining the character set.
.TP
.B LC_CTYPE
Language for determining the character set.
.TP
.B TMPDIR
The directory in which temporary files will be created.
If this is not set, temporary files will be created in
.BR /tmp .
.TP
.B XTR
Default commands for
.I xtr\fR.\fP
.TP
.B XTRPATH
A colon separated list of directories in which to search for macro files.
.TP
.B XTR_CTYPE
Language for determining the character set.
.\"
.SH FILES
.TP
.B @XTRPATH@/*
Macro files.
.TP
.B \fITMPDIR\fP/xtr\fIXXXXXX\fP
temporary file.
.\"
.SH AUTHOR
Sinyu Murakami <qga03215@niftyserve.or.jp>
.\"
.SH EDITOR
Katsuyuki Okabe <hgc02147@niftyserve.or.jp>
.\" Local variables:
.\" mode: nroff
.\" fill-column: 70
.\" End:
